| API Docs for SAX and DOM |

- Main Page
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# SAX2XMLReader Class Reference

Inheritance diagram for SAX2XMLReader:

[legend]

List of all members.

## Public Types

Public constants
enum | ValSchemes { Val_Never, Val_Always, Val_Auto }
| ValScheme enum used in setValidationScheme Val_Never: Do not report validation errors. More...

## Public Member Functions

Constructors and Destructor
| SAX2XMLReader ()
| The default constructor.
virtual | ~SAX2XMLReader ()
| The destructor.
Implementation of SAX 2.0 XMLReader interface's.
virtual ContentHandler * | getContentHandler () const =0
| This method returns the installed content handler.
virtual DTDHandler * | getDTDHandler () const =0
| This method returns the installed DTD handler.
virtual EntityResolver * | getEntityResolver () const =0
| This method returns the installed entity resolver.
virtual ErrorHandler * | getErrorHandler () const =0
| This method returns the installed error handler.
virtual bool | getFeature (const XMLCh *const name) const =0
| Query the current state of any feature in a SAX2 XMLReader.
virtual void * | getProperty (const XMLCh *const name) const =0
| Query the current value of a property in a SAX2 XMLReader.
virtual void | setContentHandler (ContentHandler *const handler)=0
| Allow an application to register a document event handler.
virtual void | setDTDHandler (DTDHandler *const handler)=0
| Allow an application to register a DTD event handler.
virtual void | setEntityResolver (EntityResolver *const resolver)=0
| Allow an application to register a custom entity resolver.
virtual void | setErrorHandler (ErrorHandler *const handler)=0
| Allow an application to register an error event handler.
virtual void | setFeature (const XMLCh *const name, const bool value)=0
| Set the state of any feature in a SAX2 XMLReader.
virtual void | setProperty (const XMLCh *const name, void *value)=0
| Set the value of any property in a SAX2 XMLReader.
virtual void | parse (const InputSource &source)=0
| Parse an XML document.
virtual void | parse (const XMLCh *const systemId)=0
| Parse an XML document from a system identifier (URI).
virtual void | parse (const char *const systemId)=0
| Parse an XML document from a system identifier (URI).
SAX 2.0-ext
virtual DeclHandler * | getDeclarationHandler () const =0
| This method returns the installed declaration handler.
virtual LexicalHandler * | getLexicalHandler () const =0
| This method returns the installed lexical handler.
virtual void | setDeclarationHandler (DeclHandler *const handler)=0
| Allow an application to register a declaration event handler.
virtual void | setLexicalHandler (LexicalHandler *const handler)=0
| Allow an application to register a lexical event handler.
Getter Methods (Xerces-C specific)
virtual XMLValidator * | getValidator () const =0
| This method is used to get the current validator.
virtual int | getErrorCount () const =0
| Get error count from the last parse operation.
virtual bool | getExitOnFirstFatalError () const =0
| This method returns the state of the parser's exit-on-First-Fatal-Error flag.
virtual bool | getValidationConstraintFatal () const =0
| This method returns the state of the parser's validation-constraint-fatal flag.
virtual Grammar * | getGrammar (const XMLCh *const nameSpaceKey)=0
| Retrieve the grammar that is associated with the specified namespace key.
virtual Grammar * | getRootGrammar ()=0
| Retrieve the grammar where the root element is declared.
virtual const XMLCh * | getURIText (unsigned int uriId) const =0
| Returns the string corresponding to a URI id from the URI string pool.
virtual unsigned int | getSrcOffset () const =0
| Returns the current src offset within the input source.
Setter Methods (Xerces-C specific)
virtual void | setValidator (XMLValidator *valueToAdopt)=0
| This method is used to set a validator.
virtual void | setExitOnFirstFatalError (const bool newState)=0
| This method allows users to set the parser's behaviour when it encounters the first fatal error.
virtual void | setValidationConstraintFatal (const bool newState)=0
| This method allows users to set the parser's behaviour when it encounters a validtion constraint error.
Progressive scan methods
virtual bool | parseFirst (const XMLCh *const systemId, XMLPScanToken &toFill)=0
| Begin a progressive parse operation.
virtual bool | parseFirst (const char *const systemId, XMLPScanToken &toFill)=0
| Begin a progressive parse operation.
virtual bool | parseFirst (const InputSource &source, XMLPScanToken &toFill)=0
| Begin a progressive parse operation.
virtual bool | parseNext (XMLPScanToken &token)=0
| Continue a progressive parse operation.
virtual void | parseReset (XMLPScanToken &token)=0
| Reset the parser after a progressive parse.
Grammar preparsing interface's.
virtual Grammar * | loadGrammar (const InputSource &source, const short grammarType, const bool toCache=false)=0
| Preparse schema grammar (XML Schema, DTD, etc.
virtual Grammar * | loadGrammar (const XMLCh *const systemId, const short grammarType, const bool toCache=false)=0
| Preparse schema grammar (XML Schema, DTD, etc.
virtual Grammar * | loadGrammar (const char *const systemId, const short grammarType, const bool toCache=false)=0
| Preparse schema grammar (XML Schema, DTD, etc.
virtual void | resetCachedGrammarPool ()=0
| Clear the cached grammar pool.
virtual void | setInputBufferSize (const size_t bufferSize)
| Set maximum input buffer size.
Advanced document handler list maintenance methods
virtual void | installAdvDocHandler (XMLDocumentHandler *const toInstall)=0
| This method installs the specified 'advanced' document callback handler, thereby allowing the user to customize the processing, if they choose to do so.
virtual bool | removeAdvDocHandler (XMLDocumentHandler *const toRemove)=0
| This method removes the 'advanced' document handler callback from the underlying parser scanner.

## Member Enumeration Documentation

enum SAX2XMLReader::ValSchemes

ValScheme enum used in setValidationScheme Val_Never: Do not report validation errors.

Val_Always: The parser will always report validation errors. Val_Auto: The parser will report validation errors only if a grammar is specified.

See also:
  setValidationScheme

Enumerator:

  Val_Never |
  Val_Always |
  Val_Auto |

## Constructor & Destructor Documentation

SAX2XMLReader::SAX2XMLReader | ( |  | ) |

The default constructor.

virtual SAX2XMLReader::~SAX2XMLReader | ( |  | ) | `[virtual]`

The destructor.

## Member Function Documentation

virtual ContentHandler* SAX2XMLReader::getContentHandler | ( |  | ) | const`[pure virtual]`

This method returns the installed content handler.

Returns:
  A pointer to the installed content handler object.

virtual DTDHandler* SAX2XMLReader::getDTDHandler | ( |  | ) | const`[pure virtual]`

This method returns the installed DTD handler.

Returns:
  A pointer to the installed DTD handler object.

virtual EntityResolver* SAX2XMLReader::getEntityResolver | ( |  | ) | const`[pure virtual]`

This method returns the installed entity resolver.

Returns:
  A pointer to the installed entity resolver object.

virtual ErrorHandler* SAX2XMLReader::getErrorHandler | ( |  | ) | const`[pure virtual]`

This method returns the installed error handler.

Returns:
  A pointer to the installed error handler object.

virtual bool SAX2XMLReader::getFeature | ( | const XMLCh *const | name | ) | const`[pure virtual]`

Query the current state of any feature in a SAX2 XMLReader.

Parameters:

  | name | The unique identifier (URI) of the feature being set.

Returns:
  The current state of the feature.

Exceptions:

  | SAXNotRecognizedException | If the requested feature is not known.

virtual void* SAX2XMLReader::getProperty | ( | const XMLCh *const | name | ) | const`[pure virtual]`

Query the current value of a property in a SAX2 XMLReader.

The parser owns the returned pointer. The memory allocated for the returned pointer will be destroyed when the parser is deleted.

To ensure assessiblity of the returned information after the parser is deleted, callers need to copy and store the returned information somewhere else; otherwise you may get unexpected result. Since the returned pointer is a generic void pointer, see http://xerces.apache.org/xerces-c/program-sax2.html#SAX2Properties to learn exactly what type of property value each property returns for replication.

Parameters:

  | name | The unique identifier (URI) of the property being set.

Returns:
  The current value of the property. The pointer spans the same life-time as the parser. A null pointer is returned if nothing was specified externally.

Exceptions:

  | SAXNotRecognizedException | If the requested property is not known.

virtual void SAX2XMLReader::setContentHandler | ( | ContentHandler *const | handler | ) | `[pure virtual]`

Allow an application to register a document event handler.

If the application does not register a document handler, all document events reported by the SAX parser will be silently ignored (this is the default behaviour implemented by HandlerBase).

Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

Parameters:

  | handler | The document handler.

See also:
  DocumentHandler::DocumentHandler

  HandlerBase::HandlerBase

virtual void SAX2XMLReader::setDTDHandler | ( | DTDHandler *const | handler | ) | `[pure virtual]`

Allow an application to register a DTD event handler.

If the application does not register a DTD handler, all DTD events reported by the SAX parser will be silently ignored (this is the default behaviour implemented by HandlerBase).

Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

Parameters:

  | handler | The DTD handler.

See also:
  DTDHandler::DTDHandler

  HandlerBase::HandlerBase

virtual void SAX2XMLReader::setEntityResolver | ( | EntityResolver *const | resolver | ) | `[pure virtual]`

Allow an application to register a custom entity resolver.

If the application does not register an entity resolver, the SAX parser will resolve system identifiers and open connections to entities itself (this is the default behaviour implemented in DefaultHandler).

Applications may register a new or different entity resolver in the middle of a parse, and the SAX parser must begin using the new resolver immediately.

Parameters:

  | resolver | The object for resolving entities.

See also:
  EntityResolver::EntityResolver

  DefaultHandler::DefaultHandler

virtual void SAX2XMLReader::setErrorHandler | ( | ErrorHandler *const | handler | ) | `[pure virtual]`

Allow an application to register an error event handler.

If the application does not register an error event handler, all error events reported by the SAX parser will be silently ignored, except for fatalError, which will throw a SAXException (this is the default behaviour implemented by HandlerBase).

Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

Parameters:

  | handler | The error handler.

See also:
  ErrorHandler::ErrorHandler

  SAXException::SAXException

  HandlerBase::HandlerBase

virtual void SAX2XMLReader::setFeature | ( | const XMLCh *const | name,
|  | const bool | value |
| ) |  |  | `[pure virtual]`

Set the state of any feature in a SAX2 XMLReader.

Supported features in SAX2 for xerces-c are:
(See http://xerces.apache.org/xerces-c/program-sax2.html#SAX2Features for detail description).

http://xml.org/sax/features/validation (default: true)
http://xml.org/sax/features/namespaces (default: true)
http://xml.org/sax/features/namespace-prefixes (default: false)
http://apache.org/xml/features/validation/dynamic (default: false)
http://apache.org/xml/features/validation/reuse-grammar (default: false)
http://apache.org/xml/features/validation/schema (default: true)
http://apache.org/xml/features/validation/schema-full-checking (default: false)
http://apache.org/xml/features/nonvalidating/load-external-dtd (default: true)
http://apache.org/xml/features/continue-after-fatal-error (default: false)
http://apache.org/xml/features/validation-error-as-fatal (default: false)
http://apache.org/xml/features/validation/reuse-validator (Deprecated) (default: false)

Parameters:

  | name | The unique identifier (URI) of the feature.
  | value | The requested state of the feature (true or false).

Exceptions:

  | SAXNotRecognizedException | If the requested feature is not known.
  | SAXNotSupportedException | Feature modification is not supported during parse

virtual void SAX2XMLReader::setProperty | ( | const XMLCh *const | name,
|  | void * | value |
| ) |  |  | `[pure virtual]`

Set the value of any property in a SAX2 XMLReader.

Supported properties in SAX2 for xerces-c are:
(See http://xerces.apache.org/xerces-c/program-sax2.html#SAX2Properties for detail description).

http://apache.org/xml/properties/schema/external-schemaLocation
http://apache.org/xml/properties/schema/external-noNamespaceSchemaLocation.

It takes a void pointer as the property value. Application is required to initialize this void pointer to a correct type. See http://xerces.apache.org/xerces-c/program-sax2.html#SAX2Properties to learn exactly what type of property value each property expects for processing. Passing a void pointer that was initialized with a wrong type will lead to unexpected result. If the same property is set more than once, the last one takes effect.

Parameters:

  | name | The unique identifier (URI) of the property being set.
  | value | The requested value for the property. See http://xerces.apache.org/xerces-c/program-sax2.html#SAX2Properties to learn exactly what type of property value each property expects for processing. Passing a void pointer that was initialized with a wrong type will lead to unexpected result.

Exceptions:

  | SAXNotRecognizedException | If the requested property is not known.
  | SAXNotSupportedException | Property modification is not supported during parse

virtual void SAX2XMLReader::parse | ( | const InputSource & | source | ) | `[pure virtual]`

Parse an XML document.

The application can use this method to instruct the SAX parser to begin parsing an XML document from any valid input source (a character stream, a byte stream, or a URI).

Applications may not invoke this method while a parse is in progress (they should create a new Parser instead for each additional XML document). Once a parse is complete, an application may reuse the same Parser object, possibly with a different input source.

Parameters:

  | source | The input source for the top-level of the XML document.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.
  | XMLException | An exception from the parser or client handler code.

See also:
  InputSource::InputSource

  setEntityResolver

  setDTDHandler

  setDocumentHandler

  setErrorHandler

virtual void SAX2XMLReader::parse | ( | const XMLCh *const | systemId | ) | `[pure virtual]`

Parse an XML document from a system identifier (URI).

This method is a shortcut for the common case of reading a document from a system identifier. It is the exact equivalent of the following:

parse(new URLInputSource(systemId));

If the system identifier is a URL, it must be fully resolved by the application before it is passed to the parser.

Parameters:

  | systemId | The system identifier (URI).

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.
  | XMLException | An exception from the parser or client handler code.

See also:
  parse(InputSource)

virtual void SAX2XMLReader::parse | ( | const char *const | systemId | ) | `[pure virtual]`

Parse an XML document from a system identifier (URI).

This method is a shortcut for the common case of reading a document from a system identifier. It is the exact equivalent of the following:

parse(new URLInputSource(systemId));

If the system identifier is a URL, it must be fully resolved by the application before it is passed to the parser.

Parameters:

  | systemId | The system identifier (URI).

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.
  | XMLException | An exception from the parser or client handler code.

See also:
  parse(InputSource)

virtual DeclHandler* SAX2XMLReader::getDeclarationHandler | ( |  | ) | const`[pure virtual]`

This method returns the installed declaration handler.

Returns:
  A pointer to the installed declaration handler object.

virtual LexicalHandler* SAX2XMLReader::getLexicalHandler | ( |  | ) | const`[pure virtual]`

This method returns the installed lexical handler.

Returns:
  A pointer to the installed lexical handler object.

virtual void SAX2XMLReader::setDeclarationHandler | ( | DeclHandler *const | handler | ) | `[pure virtual]`

Allow an application to register a declaration event handler.

If the application does not register a declaration handler, all events reported by the SAX parser will be silently ignored. (this is the default behaviour implemented by DefaultHandler).

Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

Parameters:

  | handler | The DTD declaration handler.

See also:
  DeclHandler::DeclHandler

  SAXException::SAXException

  DefaultHandler::DefaultHandler

virtual void SAX2XMLReader::setLexicalHandler | ( | LexicalHandler *const | handler | ) | `[pure virtual]`

Allow an application to register a lexical event handler.

If the application does not register a lexical handler, all events reported by the SAX parser will be silently ignored. (this is the default behaviour implemented by HandlerBase).

Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

Parameters:

  | handler | The error handler.

See also:
  LexicalHandler::LexicalHandler

  SAXException::SAXException

  HandlerBase::HandlerBase

virtual XMLValidator* SAX2XMLReader::getValidator | ( |  | ) | const`[pure virtual]`

This method is used to get the current validator.

SAX2XMLReader assumes responsibility for the validator. It will be deleted when the XMLReader is destroyed.

Returns:
  A pointer to the validator. An application should not deleted the object returned.

virtual int SAX2XMLReader::getErrorCount | ( |  | ) | const`[pure virtual]`

Get error count from the last parse operation.

This method returns the error count from the last parse operation. Note that this count is actually stored in the scanner, so this method simply returns what the scanner reports.

Returns:
  number of errors encountered during the latest parse operation.

virtual bool SAX2XMLReader::getExitOnFirstFatalError | ( |  | ) | const`[pure virtual]`

This method returns the state of the parser's exit-on-First-Fatal-Error flag.

Or you can query the feature "http://apache.org/xml/features/continue-after-fatal-error" which indicates the opposite state.

Returns:
  true, if the parser is currently configured to exit on the first fatal error, false otherwise.

See also:
  setExitOnFirstFatalError

  getFeature

virtual bool SAX2XMLReader::getValidationConstraintFatal | ( |  | ) | const`[pure virtual]`

This method returns the state of the parser's validation-constraint-fatal flag.

Or you can query the feature "http://apache.org/xml/features/validation-error-as-fatal" which means the same thing.

Returns:
  true, if the parser is currently configured to set validation constraint errors as fatal, false otherwise.

See also:
  setValidationContraintFatal

  getFeature

virtual Grammar* SAX2XMLReader::getGrammar | ( | const XMLCh *const | nameSpaceKey | ) | `[pure virtual]`

Retrieve the grammar that is associated with the specified namespace key.

Parameters:

  | nameSpaceKey | Namespace key

Returns:
  Grammar associated with the Namespace key.

virtual Grammar* SAX2XMLReader::getRootGrammar | ( |  | ) | `[pure virtual]`

Retrieve the grammar where the root element is declared.

Returns:
  Grammar where root element declared

virtual const XMLCh* SAX2XMLReader::getURIText | ( | unsigned int | uriId | ) | const`[pure virtual]`

Returns the string corresponding to a URI id from the URI string pool.

Parameters:

  | uriId | id of the string in the URI string pool.

Returns:
  URI string corresponding to the URI id.

virtual unsigned int SAX2XMLReader::getSrcOffset | ( |  | ) | const`[pure virtual]`

Returns the current src offset within the input source.

To be used only while parsing is in progress.

Returns:
  offset within the input source

virtual void SAX2XMLReader::setValidator | ( | XMLValidator * | valueToAdopt | ) | `[pure virtual]`

This method is used to set a validator.

SAX2XMLReader assumes responsibility for the validator. It will be deleted when the XMLReader is destroyed.

Parameters:

  | valueToAdopt | A pointer to the validator that the reader should use.

virtual void SAX2XMLReader::setExitOnFirstFatalError | ( | const bool | newState | ) | `[pure virtual]`

This method allows users to set the parser's behaviour when it encounters the first fatal error.

If set to true, the parser will exit at the first fatal error. If false, then it will report the error and continue processing.

The default value is 'true' and the parser exits on the first fatal error.

Or you can set the feature "http://apache.org/xml/features/continue-after-fatal-error" which has the opposite behaviour.

If both the feature above and this function are used, the latter takes effect.

Parameters:

  | newState | The value specifying whether the parser should continue or exit when it encounters the first fatal error.

See also:
  getExitOnFirstFatalError

  setFeature

virtual void SAX2XMLReader::setValidationConstraintFatal | ( | const bool | newState | ) | `[pure virtual]`

This method allows users to set the parser's behaviour when it encounters a validtion constraint error.

If set to true, and the the parser will treat validation error as fatal and will exit depends on the state of "getExitOnFirstFatalError". If false, then it will report the error and continue processing.

Note: setting this true does not mean the validation error will be printed with the word "Fatal Error". It is still printed as "Error", but the parser will exit if "setExitOnFirstFatalError" is set to true.

The default value is 'false'.

Or you can set the feature "http://apache.org/xml/features/validation-error-as-fatal" which means the same thing.

If both the feature above and this function are used, the latter takes effect.

Parameters:

  | newState | If true, the parser will exit if "setExitOnFirstFatalError" is set to true.

See also:
  getValidationConstraintFatal

  setExitOnFirstFatalError

  setFeature

virtual bool SAX2XMLReader::parseFirst | ( | const XMLCh *const | systemId,
|  | XMLPScanToken & | toFill |
| ) |  |  | `[pure virtual]`

Begin a progressive parse operation.

This method is used to start a progressive parse on a XML file. To continue parsing, subsequent calls must be to the parseNext method.

It scans through the prolog and returns a token to be used on subsequent scanNext() calls. If the return value is true, then the token is legal and ready for further use. If it returns false, then the scan of the prolog failed and the token is not going to work on subsequent scanNext() calls.

Parameters:

  | systemId | A pointer to a Unicode string represting the path to the XML file to be parsed.
  | toFill | A token maintaing state information to maintain internal consistency between invocation of 'parseNext' calls.

Returns:
  'true', if successful in parsing the prolog. It indicates the user can go ahead with parsing the rest of the file. It returns 'false' to indicate that the parser could parse the prolog (which means the token will not be valid.)

See also:
  parseNext

  parseFirst(char*,...)

  parseFirst(InputSource&,...)

virtual bool SAX2XMLReader::parseFirst | ( | const char *const | systemId,
|  | XMLPScanToken & | toFill |
| ) |  |  | `[pure virtual]`

Begin a progressive parse operation.

This method is used to start a progressive parse on a XML file. To continue parsing, subsequent calls must be to the parseNext method.

It scans through the prolog and returns a token to be used on subsequent scanNext() calls. If the return value is true, then the token is legal and ready for further use. If it returns false, then the scan of the prolog failed and the token is not going to work on subsequent scanNext() calls.

Parameters:

  | systemId | A pointer to a regular native string represting the path to the XML file to be parsed.
  | toFill | A token maintaing state information to maintain internal consIstency between invocation of 'parseNext' calls.

Returns:
  'true', if successful in parsing the prolog. It indicates the user can go ahead with parsing the rest of the file. It returns 'false' to indicate that the parser could not parse the prolog.

See also:
  parseNext

  parseFirst(XMLCh*,...)

  parseFirst(InputSource&,...)

virtual bool SAX2XMLReader::parseFirst | ( | const InputSource & | source,
|  | XMLPScanToken & | toFill |
| ) |  |  | `[pure virtual]`

Begin a progressive parse operation.

This method is used to start a progressive parse on a XML file. To continue parsing, subsequent calls must be to the parseNext method.

It scans through the prolog and returns a token to be used on subsequent scanNext() calls. If the return value is true, then the token is legal and ready for further use. If it returns false, then the scan of the prolog failed and the token is not going to work on subsequent scanNext() calls.

Parameters:

  | source | A const reference to the InputSource object which points to the XML file to be parsed.
  | toFill | A token maintaing state information to maintain internal consistency between invocation of 'parseNext' calls.

Returns:
  'true', if successful in parsing the prolog. It indicates the user can go ahead with parsing the rest of the file. It returns 'false' to indicate that the parser could not parse the prolog.

See also:
  parseNext

  parseFirst(XMLCh*,...)

  parseFirst(char*,...)

virtual bool SAX2XMLReader::parseNext | ( | XMLPScanToken & | token | ) | `[pure virtual]`

Continue a progressive parse operation.

This method is used to continue with progressive parsing of XML files started by a call to 'parseFirst' method.

It parses the XML file and stops as soon as it comes across a XML token (as defined in the XML specification). Relevant callback handlers are invoked as required by the SAX specification.

Parameters:

  | token | A token maintaing state information to maintain internal consistency between invocation of 'parseNext' calls.

Returns:
  'true', if successful in parsing the next XML token. It indicates the user can go ahead with parsing the rest of the file. It returns 'false' to indicate that the parser could not find next token as per the XML specification production rule.

See also:
  parseFirst(XMLCh*,...)

  parseFirst(char*,...)

  parseFirst(InputSource&,...)

virtual void SAX2XMLReader::parseReset | ( | XMLPScanToken & | token | ) | `[pure virtual]`

Reset the parser after a progressive parse.

If a progressive parse loop exits before the end of the document is reached, the parser has no way of knowing this. So it will leave open any files or sockets or memory buffers that were in use at the time that the parse loop exited.

The next parse operation will cause these open files and such to be closed, but the next parse operation might occur at some unknown future point. To avoid this problem, you should reset the parser if you exit the loop early.

If you exited because of an error, then this cleanup will be done for you. Its only when you exit the file prematurely of your own accord, because you've found what you wanted in the file most likely.

Parameters:

  | token | A token maintaing state information to maintain internal consistency between invocation of 'parseNext' calls.

virtual Grammar* SAX2XMLReader::loadGrammar | ( | const InputSource & | source,
|  | const short | grammarType,
|  | const bool | toCache = `false` |
| ) |  |  | `[pure virtual]`

Preparse schema grammar (XML Schema, DTD, etc.

) via an input source object.

This method invokes the preparsing process on a schema grammar XML file specified by the SAX InputSource parameter. If the 'toCache' flag is enabled, the parser will cache the grammars for re-use. If a grammar key is found in the pool, no caching of any grammar will take place.

"Experimental - subject to change"

Parameters:

  | source | A const reference to the SAX InputSource object which points to the schema grammar file to be preparsed.
  | grammarType | The grammar type (Schema or DTD).
  | toCache | If `true`, we cache the preparsed grammar, otherwise, no chaching. Default is `false`.

Returns:
  The preparsed schema grammar object (SchemaGrammar or DTDGrammar). That grammar object is owned by the parser.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.
  | XMLException | An exception from the parser or client handler code.
  | DOMException | A DOM exception as per DOM spec.

See also:
  InputSource::InputSource

virtual Grammar* SAX2XMLReader::loadGrammar | ( | const XMLCh *const | systemId,
|  | const short | grammarType,
|  | const bool | toCache = `false` |
| ) |  |  | `[pure virtual]`

Preparse schema grammar (XML Schema, DTD, etc.

) via a file path or URL

This method invokes the preparsing process on a schema grammar XML file specified by the file path parameter. If the 'toCache' flag is enabled, the parser will cache the grammars for re-use. If a grammar key is found in the pool, no caching of any grammar will take place.

"Experimental - subject to change"

Parameters:

  | systemId | A const XMLCh pointer to the Unicode string which contains the path to the XML grammar file to be preparsed.
  | grammarType | The grammar type (Schema or DTD).
  | toCache | If `true`, we cache the preparsed grammar, otherwise, no chaching. Default is `false`.

Returns:
  The preparsed schema grammar object (SchemaGrammar or DTDGrammar). That grammar object is owned by the parser.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.
  | XMLException | An exception from the parser or client handler code.
  | DOMException | A DOM exception as per DOM spec.

virtual Grammar* SAX2XMLReader::loadGrammar | ( | const char *const | systemId,
|  | const short | grammarType,
|  | const bool | toCache = `false` |
| ) |  |  | `[pure virtual]`

Preparse schema grammar (XML Schema, DTD, etc.

) via a file path or URL

This method invokes the preparsing process on a schema grammar XML file specified by the file path parameter. If the 'toCache' flag is enabled, the parser will cache the grammars for re-use. If a grammar key is found in the pool, no caching of any grammar will take place.

"Experimental - subject to change"

Parameters:

  | systemId | A const char pointer to a native string which contains the path to the XML grammar file to be preparsed.
  | grammarType | The grammar type (Schema or DTD).
  | toCache | If `true`, we cache the preparsed grammar, otherwise, no chaching. Default is `false`.

Returns:
  The preparsed schema grammar object (SchemaGrammar or DTDGrammar). That grammar object is owned by the parser.

Exceptions:

  | SAXException | Any SAX exception, possibly wrapping another exception.
  | XMLException | An exception from the parser or client handler code.
  | DOMException | A DOM exception as per DOM spec.

virtual void SAX2XMLReader::resetCachedGrammarPool | ( |  | ) | `[pure virtual]`

Clear the cached grammar pool.

void SAX2XMLReader::setInputBufferSize | ( | const size_t | bufferSize | ) | `[virtual]`

Set maximum input buffer size.

This method allows users to limit the size of buffers used in parsing XML character data. The effect of setting this size is to limit the size of a ContentHandler::characters() call.

The parser's default input buffer size is 1 megabyte.

Parameters:

  | bufferSize | The maximum input buffer size

virtual void SAX2XMLReader::installAdvDocHandler | ( | XMLDocumentHandler *const | toInstall | ) | `[pure virtual]`

This method installs the specified 'advanced' document callback handler, thereby allowing the user to customize the processing, if they choose to do so.

Any number of advanced callback handlers maybe installed.

The methods in the advanced callback interface represent Xerces-C extensions. There is no specification for this interface.

Parameters:

  | toInstall | A pointer to the users advanced callback handler.

See also:
  removeAdvDocHandler

virtual bool SAX2XMLReader::removeAdvDocHandler | ( | XMLDocumentHandler *const | toRemove | ) | `[pure virtual]`

This method removes the 'advanced' document handler callback from the underlying parser scanner.

If no handler is installed, advanced callbacks are not invoked by the scanner.

Parameters:

  | toRemove | A pointer to the advanced callback handler which should be removed.

See also:
  installAdvDocHandler

The documentation for this class was generated from the following file:

- SAX2XMLReader.hpp

Copyright © 1994-2004 The Apache Software Foundation. All Rights Reserved.